VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "FindStringInDoc"
   ClientHeight    =   4125
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4125
   ScaleWidth      =   7560
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Default         =   -1  'True
      Height          =   255
      Left            =   6720
      TabIndex        =   5
      Top             =   0
      Width           =   735
   End
   Begin VB.ListBox lstFiles 
      Height          =   3570
      Left            =   2280
      TabIndex        =   4
      Top             =   360
      Width           =   5175
   End
   Begin VB.TextBox txtString 
      Height          =   285
      Left            =   480
      TabIndex        =   3
      Text            =   "hello"
      Top             =   0
      Width           =   6135
   End
   Begin VB.DriveListBox drvSearch 
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.DirListBox dirSearch 
      Height          =   2790
      Left            =   0
      TabIndex        =   0
      Top             =   720
      Width           =   2175
   End
   Begin VB.Label Label1 
      Caption         =   "String"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text ' Case insensitive.

Private Const MAX_PATH = 260
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

'Private Const ERROR_NO_MORE_FILES = 18&
Private Const INVALID_HANDLE_VALUE = -1
Private Const DDL_DIRECTORY = &H10

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1

Private Const ERROR_FILE_NOT_FOUND = 2&
Private Const ERROR_PATH_NOT_FOUND = 3&
Private Const ERROR_BAD_FORMAT = 11&
Private Const SE_ERR_ACCESSDENIED = 5            '  access denied
Private Const SE_ERR_ASSOCINCOMPLETE = 27
Private Const SE_ERR_DDEBUSY = 30
Private Const SE_ERR_DDEFAIL = 29
Private Const SE_ERR_DDETIMEOUT = 28
Private Const SE_ERR_DLLNOTFOUND = 32
Private Const SE_ERR_FNF = 2                     '  file not found
Private Const SE_ERR_NOASSOC = 31
Private Const SE_ERR_OOM = 8                     '  out of memory
Private Const SE_ERR_PNF = 3                     '  path not found
Private Const SE_ERR_SHARE = 26

Private Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal lpResult As String) As Long

Private m_WordServer As Word.Application

' Return True if the target is in the file.
Private Function TargetInFile(fname, target) As Boolean
'Dim fnum As Integer
'Dim txt As String

    ' Open the file.
    On Error GoTo OpenError
    m_WordServer.Documents.Open FileName:=fname, ConfirmConversions:=False, _
        ReadOnly:=True, AddToRecentFiles:=False, PasswordDocument:="", _
        PasswordTemplate:="", Revert:=False, WritePasswordDocument:="", _
        WritePasswordTemplate:="", Format:=wdOpenFormatAuto

    ' Search for the target string.
    With m_WordServer.ActiveWindow.Selection.Find
        .ClearFormatting
        .Text = target
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindContinue
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
        .Execute
    End With
    TargetInFile = (m_WordServer.ActiveWindow.Selection = target)

    ' Close the file.
    m_WordServer.ActiveDocument.Close False
    Exit Function

OpenError:
    Exit Function
End Function
' Search all files below the directory that
' match the pattern.
Private Sub CheckFiles(ByVal start_dir As String, ByVal pattern As String, ByVal target As String)
Const MAXDWORD = 2 ^ 32

Dim dir_names() As String
Dim num_dirs As Integer
Dim i As Integer
Dim fname As String
Dim new_files As String
Dim attr As Integer
Dim search_handle As Long
Dim file_data As WIN32_FIND_DATA
Dim file_size As Double

    ' Get the matching files in this directory.
    ' Get the first file.
    search_handle = FindFirstFile( _
        start_dir & pattern, file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            fname = file_data.cFileName
            fname = start_dir & Left$(fname, InStr(fname, Chr$(0)) - 1)

            If TargetInFile(fname, target) Then
                lstFiles.AddItem fname
                lstFiles.Refresh
            End If

            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search hanlde.
        FindClose search_handle
    End If

    ' Optionally display the new list here.

    ' Get the list of subdirectories.
    search_handle = FindFirstFile( _
        start_dir & "*.*", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            If file_data.dwFileAttributes And DDL_DIRECTORY Then
                fname = file_data.cFileName
                fname = Left$(fname, InStr(fname, Chr$(0)) - 1)
                If fname <> "." And fname <> ".." Then
                    num_dirs = num_dirs + 1
                    ReDim Preserve dir_names(1 To num_dirs)
                    dir_names(num_dirs) = fname
                End If
            End If
            
            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search handle.
        FindClose search_handle
    End If

    ' Search the subdirectories.
    For i = 1 To num_dirs
        CheckFiles start_dir & dir_names(i) & "\", pattern, target
    Next i
End Sub
' Search the selected files.
Private Sub cmdSearch_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer
Dim patterns As Variant
Dim start_dir As String
Dim i As Integer

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Create the Word server.
    Set m_WordServer = New Word.Application

    ' Copy the patterns into an array.
    pat = "*.doc"
    patterns = Split(pat, ";")

    ' Search the files.
    lstFiles.Clear
    start_dir = dirSearch.Path
    If Right$(start_dir, 1) <> "\" Then start_dir = start_dir & "\"
    For i = LBound(patterns) To UBound(patterns)
        CheckFiles start_dir, patterns(i), txtString.Text
    Next i

    ' Destroy the Word server.
    m_WordServer.Quit False
    Set m_WordServer = Nothing

    Screen.MousePointer = vbDefault
End Sub
Private Sub drvSearch_Change()
    'On Error GoTo DriveError
    dirSearch.Path = drvSearch.Drive
    Exit Sub

DriveError:
    drvSearch.Drive = dirSearch.Path
    Exit Sub
End Sub


Private Sub Form_Load()
    drvSearch.Drive = App.Path
    dirSearch.Path = App.Path

    cmdSearch.Height = txtString.Height
    cmdSearch.Enabled = (Len(txtString.Text) > 0)
End Sub

Private Sub Form_Resize()
Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    hgt = ScaleHeight - (drvSearch.Top + drvSearch.Height)
    If hgt < 120 Then hgt = 120
    dirSearch.Height = hgt

    cmdSearch.Left = ScaleWidth - cmdSearch.Width

    wid = cmdSearch.Left - txtString.Left - 60
    If wid < 120 Then wid = 120
    txtString.Width = wid

    wid = ScaleWidth - lstFiles.Left
    If wid < 120 Then wid = 120
    lstFiles.Width = wid

    hgt = ScaleHeight - lstFiles.Top
    If hgt < 120 Then hgt = 120
    lstFiles.Height = hgt
End Sub

Private Sub lstFiles_DblClick()
    Select Case ShellExecute(hwnd, "open", _
        lstFiles.Text, vbNullString, _
        vbNullString, SW_SHOWNORMAL)

        Case 0
            MsgBox "Out of memory or resources"
        Case ERROR_BAD_FORMAT
            MsgBox "Invalid file format"
        Case SE_ERR_ACCESSDENIED
            MsgBox "Access denied"
        Case SE_ERR_ASSOCINCOMPLETE
            MsgBox "Incomplete or invalid file name association"
        Case SE_ERR_DDEBUSY
            MsgBox "DDE busy"
        Case SE_ERR_DDEFAIL
            MsgBox "DDE transaction failed"
        Case SE_ERR_DDETIMEOUT
            MsgBox "DDE request timed out"
        Case SE_ERR_DLLNOTFOUND
            MsgBox "DLL not found"
        Case ERROR_FILE_NOT_FOUND, SE_ERR_FNF
            MsgBox "File not found"
        Case SE_ERR_NOASSOC
            MsgBox "No associated application or file not printable"
        Case SE_ERR_OOM
            MsgBox "Out of memory"
        Case ERROR_PATH_NOT_FOUND, SE_ERR_PNF
            MsgBox "Path not found"
        Case SE_ERR_SHARE
            MsgBox "Sharing violation"
    End Select
End Sub

Private Sub txtString_Change()
    cmdSearch.Enabled = (Len(txtString.Text) > 0)
End Sub


